<template>
  <div v-if="user.authenticated">
    <h1 v-lang.authors.title></h1>

    <div class="ui info message" v-if="loading">
      <icon name="refresh" spin></icon>&nbsp;&nbsp;
      <span v-lang.general.loading></span>
    </div>

    <div v-if="!loading">

      <router-link to="/authors/add" class="ui green labeled icon button" style="float: right;">
        <i class="plus icon"></i>
        <span v-lang.authors.newAuthor></span>
      </router-link>

      <button @click="loadAuthors()" class="ui teal labeled icon button" style="float: right;">
        <i class="refresh icon"></i>
        <span v-lang.general.refresh></span>
      </button>

      <form id="search">
        <div class="ui icon input">
          <input :placeholder="langGeneral.search" type="text" v-model="searchQuery" v-focus>
          <i class="search icon"></i>
        </div>
      </form>
      <paginate
        name="authors"
        :list="filteredData"
        :per="35"
        tag="div"
      >
        <grid
          :data="paginated('authors')"
          :columns="gridColumns"
          :buttons="gridButtons"
          :btnclick="gridBtnClicked"
        >
        </grid>
      </paginate>
      <div class="pagination-container">
        <paginate-links
          tag="div"
          for="authors"
          :hide-single-page="true"
          :classes="{
            'ul': ['ui', 'pagination', 'menu'],
            'li': 'item',
            'li a': 'pagination-link'
          }"
        >
        </paginate-links>
        <div v-if="$refs.paginator" v-lang.general.searchResultCount="$refs.paginator.pageItemsCount"></div>
      </div>
    </div>
    <modal
      v-if="showModal"
      @close="showModal = false"
      v-on:submit="deleteBtnSuccess()">
      <span slot="header" v-lang.authors.deleteHeader></span>
      <p slot="text" v-lang.authors.deleteMsg></p>
    </modal>
  </div>
</template>

<script>
import auth from '../auth'
import {HTTP} from '../http-common'
import router from '../router'

export default {
  name: 'Authors',
  data () {
    return {
      user: auth.user,
      authors: [],
      searchQuery: '',
      gridColumns: [],
      gridButtons: [
        {
          text: '',
          icon: 'trash',
          action: this.DeleteAuthor,
          css: 'ui red icon button'
        },
        {
          text: '',
          icon: 'edit',
          action: this.editauthor,
          css: 'ui blue icon button'
        }
      ],
      loading: false,
      paginate: ['authors'],
      allStatus: [],
      showModal: false
    }
  },
  created () {
    this.loadAuthors()

    this.gridButtons[0].text = this.translate('general').delete
    this.gridColumns = [this.translate('general').name]

    // Set the title
    document.title = this.translate('nav').authors
  },
  watch: {
    // call again the method if the route changes
    '$route': 'loadAuthors'
  },
  computed: {
    filteredData: function () {
      let filterKey = this.searchQuery && this.searchQuery.toLowerCase()
      let data = this.authors
      if (filterKey) {
        data = data.filter(function (row) {
          return Object.keys(row).some(function (key) {
            if (row[key].content) {
              return String(row[key].content).toLowerCase().indexOf(filterKey) > -1
            } else {
              return String(row[key]).toLowerCase().indexOf(filterKey) > -1
            }
          })
        })
      }
      return data
    },
    langGeneral () {
      return this.translate('general')
    }
  },
  methods: {
    errorNotification (e) {
      // Build the notification text from error response
      let err = e.message
      if (e.response.data.message) {
        err += '<br/>' + e.response.data.message
      }

      // Fire a notification
      this.$notify({
        type: 'error',
        title: this.langGeneral.error,
        text: err
      })
    },
    loadAuthors () {
      this.loading = true
      this.authors = []
      HTTP.get(`authors`)
        .then(response => {
          let bs = response.data
          let i = 0

          // Loop throught the data we got from our API and prepare an array to display all authors
          for (const b in bs) {
            this.authors[i] = {
              id: {content: bs[b].id, hide: true}, // Don't show the ID
              name: {content: bs[b].forename + ' ' + bs[b].lastname, link: '/authors/' + bs[b].id} // Add a link to the element
            }

            // increment dat shit
            i++
          }

          this.loading = false
        })
        .catch(e => {
          this.loading = false
          this.errorNotification(e)
        })
    },
    gridBtnClicked (opt, gridObject) {
      opt.action(gridObject)
    },
    deleteBtnSuccess () { // Event helper function
      this.$emit('delete-submit')
    },
    DeleteAuthor (obj) {
      this.showModal = true
      this.$on('delete-submit', function () {
        // Prevent deleting already deleted authors
        if (obj) {
          HTTP.delete('authors/' + obj.id.content, { headers: {'Authorization': 'Bearer ' + localStorage.getItem('token')} })
            .then(response => {
              if (response.status === 200 && response.data.message === 'success') {
                // Fire a notification
                this.$notify({
                  type: 'success',
                  title: this.langGeneral.success,
                  text: this.translate('authors').deleteSuccess
                })
                this.loadAuthors()
              }
            })
            .catch(e => {
              this.errorNotification(e)
              this.loadAuthors()
            })
        }
        obj = null
        this.showModal = false
      })
    },
    editauthor (author) {
      router.push({ name: 'author-edit', params: { id: author.id.content } })
    }
  }
}
</script>

<style>
  a.pagination-link{
    margin: -5px -1.14286em -18px;
    display: block;
    position: absolute;
    cursor: pointer;
    padding: 0.928571em 1.14286em;
    color: rgba(0,0,0,.87);

    -webkit-transition: background-color 200ms; /* Safari */
    transition: background-color 200ms;
  }

  a.pagination-link:hover{
    background: rgba(0,0,0,.02);
  }

  .pagination{
    padding: 0;
  }

  .pagination-container{
    margin-top: 1rem;
    text-align: center;
  }

  #search{
    margin-bottom: 1rem;
  }
</style>
